<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import receiptService from '@/services/receipt'
// import DialogReceipt from '../POS/DialogReceipt.vue'

import { nextTick, onMounted, ref } from 'vue'
import type { Receipt } from '@/types/Receipt'
import { useLoadingStore } from '@/stores/loading'
import { usePermissionStore } from '@/stores/permission'
import DialogReceipt from '../POS/DialogReceipt.vue'
import { useRoute } from 'vue-router'

const permissionStore = usePermissionStore()
const loadingStore = useLoadingStore()
const receipts = ref<Receipt[]>([])
const dialogDetail = ref(false)
const selectedReceipt = ref<Receipt | null>(null)
  const route = useRoute()
const tab = ref(null)

const form = ref(false)
const dialog = ref(false)
const receiptStore = useReceiptStore()
let editedIndex = -1
const dialogDelete = ref(false)
const editedReceipt = ref<Receipt>(JSON.parse(JSON.stringify(receiptStore.receipts)))
const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Date',
    key: 'created',
    width: '300px'
  },
  {
    title: 'Total Before',
    key: 'total_before'
  },
  {
    title: 'total',
    key: 'total'
  },
  {
    title: 'Received Amount',
    key: 'receivedAmount'
  },
  {
    title: 'Chanel',
    key: 'channel'
  },
  {
    title: 'Member Discount',
    key: 'member_discount'
  },
  {
    title: 'Payment Type',
    key: 'paymentType'
  },
  {
    title: 'User ID',
    key: 'userId'
  },
  {
    title: 'User',
    key: 'user',
    value: (item: Receipt) => (item.user && item.user.fullName ? item.user.fullName : 'He'),
    width: '150px'
  },
  {
  title: 'Member Name',
  key: 'member.name',
  value: (item: Receipt) => (item.member && item.member.name ? item.member.name:""),
},

  {
    title: 'Branch Name',
    key: 'branch',
    value: (item: Receipt) => (item.branch && item.branch.name ? item.branch.name:""),
  },
  {
    title: 'Reciept Item',
    key: 'recieptItem',
    width: '300px',
    sortable: false,
    value: (item: any | Receipt) => {
      if (item && item.recieptItem) {
        return item.recieptItem
          .map((product: any) => {
            return `
                Name: ${product.name}
                Price: ${product.price}
                Unit: ${product.unit}
              `
          })
          .join('////////')
      }

      return ''
    }
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const rec = receiptStore.receipts

const deleteItem = (item: Receipt) => {
  editedIndex = receipts.value.indexOf(item)
  editedReceipt.value = Object.assign({}, item)
  dialogDelete.value = true
}

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  editedIndex = -1
}

async function getReceiptsByMember() {
  loadingStore.doLoad()
  const res = await receiptService.getReceiptsByMember(nowId.value)
  receipts.value = res.data
  console.log(res.data)

  loadingStore.finish()
}
async function deleteItemConfirm() {
  if (editedIndex !== -1) {
    const deletedItem = receipts.value[editedIndex]
    try {
      await receiptService.rmReceipt(deletedItem)
      receipts.value.splice(editedIndex, 1)
      closeDelete()
    } catch (error) {
      console.error('Error deleting receipt:', error)
    }
  }
}

const nowId = ref(0)

onMounted(() => {
  
  const strUser = JSON.parse(localStorage.getItem('user') || '')

  try {
    if (strUser) {
      const parsedUser = strUser
      nowId.value = parsedUser.id
    }
    receiptStore.getReceiptsByMember(nowId.value)
  } catch (error) {
    console.error('Error parsing user data:', error)
  }
})

</script>
<template>
  <v-parallax height="350" src="\src\assets\member\coffeebg.png">
    <div class="d-flex flex-column fill-height justify-center align-center text-white">
      <h4 style="color: #dca784" class="subheading">
        EVERYTHING FOR YOUR PERFECT BREWING EXPERIENCE
      </h4>
      <h1 style="font-size: 100px">COFFEE & MERCH</h1>
      <br />
      <h1><login-btn></login-btn></h1>
    </div>
  </v-parallax>
  <div>
    <v-tabs v-model="tab" align-tabs="center" color="#f86c04">
      <v-tab
        @click="console.log()"
        :class="{ active: route.name === 'PromotionMember' }"
        :to="{ path: '/PromotionMember' }"
        >Promotion</v-tab
      >
      <v-tab
        @click="console.log()"
        :class="{ active: route.name === 'purchase' }"
        :to="{ path: '/Purchase' }"
        >Purchase</v-tab
      >

      <v-tab
        @click="console.log()"
        :class="{ active: route.name === 'historymember' }"
        :to="{ path: '/Historymember' }"
        >History</v-tab
      >
      <v-tab
        @click="console.log()"
        :class="{ active: route.name === 'account' }"
        :to="{ path: '/AccountMember' }"
        >Account</v-tab
      >
    </v-tabs>
    <br />
    <div>
      <PromotionMemberView></PromotionMemberView>
    </div>
  </div>

  <div>
    <v-data-table :headers="headers" :items="receiptStore.receipts">
      <template v-slot:[`item.recieptItem`]="{ item }">
        <v-icon size="small" @click="receiptStore.showReceiptDialog2(item)" class="me-2">
          mdi-eye
        </v-icon>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:top>
        <v-toolbar flat style="background-color: #212121; color: white">
          <v-toolbar-title>Receipt History</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="700">
            <v-card>
              <v-card-title>
                <span class="text-h5">Receipt History</span>
              </v-card-title>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
    </v-data-table>
    <DialogReceipt></DialogReceipt>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>
<style scoped></style>
